local lg = love.graphics

function love.load()
  Gradient = require("Gradient")
  g1 = require("blue")            -- saved output from gradient editor
  g2 = require("greenyellow")
  grad = Gradient:new(g1)         -- instantiate a new gradient object
  
  grad1 = grad
  grad2 = Gradient:new(g1)
  grad3 = Gradient:new(g2)
  grad2:setFilter("linear", "linear")
  
  timer = 0
end

function love.update(dt)
  timer = timer + dt
  if timer > 5 then
    if grad == grad1 then
      grad = grad2
    elseif grad == grad2 then
      grad = grad3
    else
      grad = grad1
    end
    
    timer = 0
  end

  polygon_angle = polygon_angle or 0
  polygon_angle = polygon_angle + 0.3*dt
  
  t = t or 0
  t = t + dt
  local f = 0.5 + 0.5*math.sin(0.5*t)
  local min, max = 0.5*math.pi - 0.6, 0.5*math.pi + 0.6
  rect_angle = rect_angle or 0
  rect_angle = min + f*(max - min)
  
  circle_angle = circle_angle or 0
  circle_angle = circle_angle - 1*dt
end

function love.draw()
  lg.setBackgroundColor(255, 255, 255, 255)
  lg.setColor(255, 255, 255, 255)
  
  grad:setDirection(circle_angle)
  grad:drawCircle(250, 400, 100)
  
  grad:setDirection(rect_angle)
  grad:drawRectangle(400, 20, 300, 400)
  
  grad:setDirection(polygon_angle)
  grad:drawPolygon(101, 101, 220, 101, 260, 220, 150, 250, 80, 220)
end
